{ ------------------------------------------------------------- }
{                                                               }
{   Name:           SysUtlEx.pas                                }
{   Version:        V 0.1                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    System Utils and Types Defs                 }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  01/18/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/18/99   V0.1 -  First Version.                          }
{                                                               }
{   Gratefulness: * At RXLib Team Develope. It's the best       }
{                   Freeware Library. Thanks for all.           }
{                   Authors:                                    }
{                       Fedor Koshevnikov  (fkozh@usa.net)      }
{                       Igor Pavluk        (ipavluk@usa.net)    }
{                       Serge Korolev      (korolev@usa.net)    }
{                                                               }
{                       FidoNet: 2:5020/104                     }
{                                                               }
{                   Software development department.            }
{                       Master-Bank.                            }
{                       Moscow, Russia.                         }
{                                                               }
{                 * Brad Stowers for all componets, great work  }
{                   thanks for all.                             }
{                   e-mail: bstowers@pobox.com                  }
{                   http://www.pobox.com/~bstowers/delphi/      }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{$I XTools.Inc } { Directives for all controls }

unit SysUtlEx;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}

    Classes, Controls;              { Default Units }

//    GraphExt;                       { My Units      }

{
// --------------------------------------------------------
// Copy from RXLIB 2.50, unit VCLUTILS.PAS
// --------------------------------------------------------
}
{$IFNDEF DFS_COMPILER_4}
{$IFDEF WIN32}
{$IFDEF VER90}
const

  { Mouse Wheel message }

  WM_MOUSEWHEEL    =    $020A;
  WHEEL_DELTA      =      120;
  WHEEL_PAGESCROLL = MAXDWORD;

  SM_MOUSEWHEELPRESENT    =    75;
  MOUSEEVENTF_WHEEL       = $0800;
  SPI_GETWHEELSCROLLLINES =   104;
  SPI_SETWHEELSCROLLLINES =   105;

{$ENDIF} { // VER90 }


{$IFDEF DFS_DELPHI_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}  { // DFS_DELPHI_3_UP }

    Str_Load         = 'Load';
    Str_Save         = 'Save';
    Str_Copy         = 'Copy';
    Str_Clear        = 'Clear';
    Str_Bitmap       = 'Bitmap';
    Str_Color        = 'Color';
    Str_Light        = 'Light';
    Str_Shadow       = 'Shadow';
    Str_Border       = 'Border';
    Str_FixColor     = 'Fix Color';
    Str_Transparent  = 'Transparent';
    Str_Width        = 'Width';
    Str_Style        = 'Style';
    Str_Btn_Ok       = 'Ok';
    Str_Btn_Cancel   = 'Cancel';
    Str_Efects       = 'Efects';

    Str_Align        = 'Align';
    Str_Align_Efects = 'eaTopLeft'      +
                    #13'aeTopCenter'    +
                    #13'aeTopRight'     +
                    #13'aeCenterLeft'   +
                    #13'aeCenter'       +
                    #13'aeCenterRight'  +
                    #13'aeBottomLeft'   +
                    #13'aeBottomCenter' +
                    #13'aeBottomRight';

    Str_Version  = 'V0.1';
    Str_About_XTools = 'XSoft Tools V0.1 (C) 1999'+#13+#10+''+#13+#10+
                     'Design by:'+#13+#10+''+#13+#10+
                     '          Erick I. Jimenez Alvarado       '+#13+#10+
                     '          e-mail: erickj@usa.net'+#13+#10+
                     '   web page : http://members.xoom.com/erickj';

type

  TWMMouseWheel = record
    Msg  : Cardinal;
    Keys : Word;
    Delta: Word;
    case Integer of
      0: (
        XPos: Smallint;
        YPos: Smallint);
      1: (
        Pos   : TSmallPoint;
        Result: Longint);
  end;

{$ENDIF} { // WIN32 }

{$ENDIF} { // DFS_COMPILER_4 }

type

  { Type Based on GradientForm by Brad Stowers }

  {$IFDEF DFS_CPPB}

  PHDC = pointer;

  {$ELSE}

  PHDC = HDC;

  {$ENDIF}  { // DFS_CPPB }


function  IsForegroundTask: Boolean;
procedure FreeUnusedOle;

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}

Implementation

Uses
    SysUtils;

{
// --------------------------------------------------------
// Copy from RXLIB 2.50, unit VCLUTILS.PAS
// --------------------------------------------------------
}
{ Check if this is the active Windows task }
{ Copied from implementation of FORMS.PAS  }

type
  PCheckTaskInfo = ^TCheckTaskInfo;
  TCheckTaskInfo = record
    FocusWnd: HWnd;
    Found: Boolean;
  end;

function CheckTaskWindow(Window: HWnd; Data: Longint): WordBool;
  {$IFDEF WIN32} stdcall {$ELSE} export {$ENDIF};
begin
  Result := True;
  if PCheckTaskInfo(Data)^.FocusWnd = Window then begin
    Result := False;
    PCheckTaskInfo(Data)^.Found := True;
  end;
end;

function IsForegroundTask: Boolean;
var
  Info: TCheckTaskInfo;
{$IFNDEF WIN32}
  Proc: TFarProc;
{$ENDIF}
begin
  Info.FocusWnd := GetActiveWindow;
  Info.Found := False;
{$IFDEF WIN32}
  EnumThreadWindows(GetCurrentThreadID, @CheckTaskWindow, Longint(@Info));
{$ELSE}
  Proc := MakeProcInstance(@CheckTaskWindow, HInstance);
  try
    EnumTaskWindows(GetCurrentTask, Proc, Longint(@Info));
  finally
    FreeProcInstance(Proc);
  end;
{$ENDIF}
  Result := Info.Found;
end;


procedure FreeUnusedOle;
begin
{$IFDEF WIN32}
  FreeLibrary(GetModuleHandle('OleAut32'));
{$ENDIF}
end;

function LoadDLL(const LibName: string): THandle;
var
  ErrMode: Cardinal;
{$IFNDEF WIN32}
  P: array[0..255] of Char;
{$ENDIF}
begin
  ErrMode := SetErrorMode(SEM_NOOPENFILEERRORBOX);
{$IFDEF WIN32}
  Result := LoadLibrary(PChar(LibName));
{$ELSE}
  Result := LoadLibrary(StrPCopy(P, LibName));
{$ENDIF}
  SetErrorMode(ErrMode);
  if Result < HINSTANCE_ERROR then
{$IFDEF WIN32}
    Win32Check(False);
{$ELSE}
    raise EOutOfResources.CreateResFmt(SLoadLibError, [LibName]);
{$ENDIF}
end;

{$IFNDEF DFS_COMPILER_3_UP}
function Win32Check(RetVal: Bool): Bool;
var
  LastError: DWORD;
begin
  if not RetVal then begin
    LastError := GetLastError;
    raise Exception.CreateFmt('%s (%d)', [SysErrorMessage(LastError),
      LastError]);
  end;
  Result := RetVal;
end;
{$ENDIF} { // DFS_COMPILER_3_UP }

End.
