{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XBevCls.pas                                 }
{   Version:        V 0.2                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Class ObjBevel                              }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  01/21/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    01/11/99   V0.1 -  First Version.                          }
{    01/21/99   V0.2 -  Enhanced functions, correct few bugs.   }
{                                                               }
{   Gratefulness: * Brad Stowers for all componets, great work  }
{                   thanks for all.                             }
{                   e-mail: bstowers@pobox.com                  }
{                   http://www.pobox.com/~bstowers/delphi/      }
{                                                               }
{                 * Kerstin Thaler for component sTktMultiBevel }
{                   thansk for all.                             }
{                   e-mail: MuK.Thaler@T-Online.de              }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XBevCls;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs;             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}

    Classes, Graphics,              { Default Units }

    GraphExt;                       { My Units      }

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

const

  { Default Border      }
  ebDefault_Bevel_Width = $00000101;
  Max_Bevel_Width   = 100;

type

  { Mode how handle Bevel }
  TEnhBevelSet  = (ebmCustom, ebmTransparent, ebmFixColor);
  TEnhBevelMode = set of TEnhBevelSet;

  TEnhFrameWidth = packed record
    case boolean of
      TRUE:  ( Width : DWORD );
      FALSE: ( Inner,                               { Inner  Width      }
               Outer,                               { Outter Width      }
               BorderInner,                         { Border Inner Width }
               BorderOuter: BYTE );                 { Border Outer Width }
  end;

type

{
// --------------------------------------------------------
//  TObjBevel Class
// --------------------------------------------------------
}
  TObjBevel = class(TPersistent)

  private

    FLock       : Byte;                 { Lock events                   }

    FOnChange   : TNotifyEvent;         { handle for change on property }

  protected

    FMode        : TEnhBevelMode;

    FInnerStyle  : TEnhFrameStyle;
    FInnerSides  : TEnhSides;

    FOuterStyle  : TEnhFrameStyle;
    FOuterSides  : TEnhSides;

    FFrameWidth  : TEnhFrameWidth;

    FLightColor  : TColor;
    FShadowColor : TColor;
    FBorderColor : TColor;

    procedure SetMode(Value : TEnhBevelMode);
    procedure SetSides(Index: Integer; Value: TEnhSides);
    procedure SetStyle(Index: Integer; Value: TEnhFrameStyle);
    procedure SetWidth(Index: Integer; Value: Byte);
    procedure SetColor(Index: Integer; Value: TColor);

  protected

    procedure   Lock;
    procedure   UnLock(Value:Boolean);

  public

    constructor Create; dynamic;
//    destructor  Destroy; override;

    function    AdjustRect(aRect: TRect): TRect;
    function    PaintDC(FHandle:HDC; aRect: TRect): TRect; //dynamic;

    procedure   Assign(Source: TPersistent); override;
    procedure   Invalidate; // dynamic;

    function    IsEmpty : Boolean;

    property    OnChange : TNotifyEvent read FOnChange write FOnChange;

  published

    property Mode       : TEnhBevelMode  read FMode write SetMode
                            default [];

    property InnerStyle : TEnhFrameStyle index 0 read FInnerStyle write SetStyle
                            default efsNone;
    property OuterStyle : TEnhFrameStyle index 1 read FOuterStyle write SetStyle
                            default efsNone;

    property InnerSides : TEnhSides index 0 read FInnerSides write SetSides
                            default [esdLeft, esdTop, esdRight, esdBottom];
    property OuterSides : TEnhSides index 1 read FOuterSides write SetSides
                            default [esdLeft, esdTop, esdRight, esdBottom];

    property InnerWidth : Byte      index 0 read FFrameWidth.Inner write SetWidth
                            default 1;
    property OuterWidth : Byte      index 1 read FFrameWidth.Outer write SetWidth
                            default 1;

    property BorderInnerWidth:Byte index 2 read FFrameWidth.BorderInner write SetWidth
                            default 0;
    property BorderOuterWidth:Byte index 3 read FFrameWidth.BorderOuter write SetWidth
                            default 0;

    property BorderColor: TColor index 0 read FBorderColor write SetColor
                            default clBtnFace;
    property LightColor : TColor index 1 read FLightColor  write SetColor
                            default clBtnHighlight;
    property ShadowColor: TColor index 2 read FShadowColor write SetColor
                            default clBtnShadow;

  end;

{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}
implementation

{$ENDIF} { // PRG_UNIT }

{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
constructor TObjBevel.Create;
begin
    inherited Create;

    FInnerStyle := efsNone;                         { Default Inner Style   }
    FOuterStyle := efsNone;                         { Default Outer Style   }
    FFrameWidth.Width := ebDefault_Bevel_Width;     { Default Width for all }

    FBorderColor := clBtnFace;                      { Default Border Color  }
    FShadowcolor := clBtnShadow;                    { Default Shadow Color  }
    FLightColor  := clBtnHighlight;                 { Default Light  Color  }


    FInnerSides := [esdLeft, esdTop, esdRight, esdBottom]; { No sides in custom Mode }
    FOuterSides := [esdLeft, esdTop, esdRight, esdBottom]; { No sides in custom Mode }

    FMode       := [];                              { Default Mode Draw     }
end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
//destructor TObjBevel.Destroy;
//begin
//    inherited destroy;
//end;

{
// --------------------------------------------------------
//  Copy all Properties to self
// --------------------------------------------------------
}
procedure TObjBevel.Assign(Source: TPersistent);
begin

    if (Source = self) then
        exit;

    { Check if correct class }
    if (Source is TObjBevel) then
    Begin

        FLock := 1;                   { Lock Events           }

      try

        FInnerStyle := TObjBevel(Source).FInnerStyle;
        FOuterStyle := TObjBevel(Source).FOuterStyle;
        FInnerSides := TObjBevel(Source).FInnerSides;
        FOuterSides := TObjBevel(Source).FOuterSides;
        FFrameWidth := TObjBevel(Source).FFrameWidth;
        FBorderColor:= TObjBevel(Source).FBorderColor;
        FLightColor := TObjBevel(Source).FLightColor;
        FShadowColor:= TObjBevel(Source).FShadowColor;
        FMode       := TObjBevel(Source).FMode;

      finally

        FLock := 0;                   { UnLock Events         }
        Invalidate;

      end;

        Exit;

    end;

    { Call inherited }
    inherited Assign(Source);
end;



{
// --------------------------------------------------------
//  Set Work Mode
// --------------------------------------------------------
}
procedure TObjBevel.SetMode(Value : TEnhBevelMode);
begin
    if (Value <> FMode) then
    Begin
        FMode := Value;
        Invalidate;                             { Notify change         }
    End;
end;


{
// --------------------------------------------------------
//  Set Width
// --------------------------------------------------------
}
procedure TObjBevel.SetWidth(Index: Integer; Value: Byte);
begin

    if (Value > Max_Bevel_Width) then
        Value := Max_Bevel_Width;


    case Index of
        0 : if (FFrameWidth.Inner = Value) then
                exit
            else
                FFrameWidth.Inner := Value;

        1 : if (FFrameWidth.Outer = Value) then
                exit
            else
                FFrameWidth.Outer := Value;

        2 : if (FFrameWidth.BorderInner = Value) then
                exit
            else
                FFrameWidth.BorderInner := Value;

        3 : if (FFrameWidth.BorderOuter = Value) then
                exit
            else
                FFrameWidth.BorderOuter := Value;
    end;

    Invalidate;
end;


{
// --------------------------------------------------------
//  Put Correct Style
// --------------------------------------------------------
}
procedure TObjBevel.SetStyle(Index: Integer; Value: TEnhFrameStyle);
begin

    if (Index = 0) then
    Begin
        if (FInnerStyle = Value) then
            exit
        else
            FInnerStyle := Value;
    end
    else
    Begin
        if (FOuterStyle = Value) then
            exit
        else
            FOuterStyle := Value;
    end;

    Invalidate;
end;


{
// --------------------------------------------------------
//  Correct Colors
// --------------------------------------------------------
}
procedure TObjBevel.SetSides(Index: Integer; Value: TEnhSides);
begin

    if not (ebmCustom in FMode) then
        exit;

    if (Index = 0) then
    Begin
        if (FInnerSides = Value) then
            exit
        else
            FInnerSides := Value;
    end
    else
    Begin
        if (FOuterSides = Value) then
            exit
        else
            FOuterSides := Value;
    end;

    Invalidate;
end;

{
// --------------------------------------------------------
//  Put Correct Color
// --------------------------------------------------------
}
procedure TObjBevel.SetColor(Index : Integer; Value: TColor);
begin
    case Index of
        0 : if (FBorderColor = Value) then
                exit
            else
                FBorderColor := Value;

        1 : if (FLightColor  = Value) then
                exit
            else
                FLightColor := Value;

        2 : if (FShadowColor = Value) then
                exit
            else
                FShadowColor := Value;
    end;
    Invalidate;
end;


{
// --------------------------------------------------------
//  Refresh Data and call Event OnChange
// --------------------------------------------------------
}
procedure TObjBevel.Invalidate;
Var
    TmpCol : TRGBMap;
begin
    { Check if lock procedure }
    if (FLock = 1) then
        Exit;

    { Check for Correct Colors }
    if (ebmFixColor in FMode) then
    Begin
        TmpCol := TRGBMap(ColorToRGB(FBorderColor));
        FLightColor := TColor(MergeColorExt(TmpCol,RGBWhiteColor,70));
        FShadowColor:= TColor(MergeColorExt(TmpCol,RGBBlackColor,30));
    End;

    { Correct Sides }
    if not (ebmCustom in FMode) then
    Begin
        FInnerSides := [esdLeft, esdTop, esdRight, esdBottom];
        FOuterSides := [esdLeft, esdTop, esdRight, esdBottom];
    End;

    { Call event on object change }
    if Assigned(FOnChange) then
        FOnChange(Self);
end;

{
// --------------------------------------------------------
//  Lock Events
// --------------------------------------------------------
}
procedure TObjBevel.Lock;
begin
    FLock := 1;
end;

{
// --------------------------------------------------------
//  UnLock Events
// --------------------------------------------------------
}
procedure TObjBevel.UnLock(Value:Boolean);
begin

    FLock := 0;

    if (Value) then
        Invalidate;                         { Notify change             }
end;

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}
function  TObjBevel.PaintDC(FHandle:HDC; aRect: TRect): TRect;
Var
    Border,
    Light,
    Shadow : TRGBMap;

Begin

  {$IFNDEF DEBUGCODE}

    if (FLock = 1) or (FHandle = 0) or IsRectEmpty(aRect) then
        Exit;

  {$ELSE}

    if (FLock = 1) or IsRectEmpty(aRect) then
        Exit;


    if (FHandle = 0)  then
    Begin
        raise Exception.Create('TObjBevel::PaintDC: Handle not valid');
        Exit;
    End;

  {$ENDIF} { // DEBUGCODE }


    Light  := TRGBMap(ColorToRGB(FLightColor ));
    Shadow := TRGBMap(ColorToRGB(FShadowColor));
    Border := TRGBMap(ColorToRGB(FBorderColor));

    if not (ebmCustom in FMode) then
    begin

        { Draw Outer Bevl }
        if (FOuterStyle <> efsNone) then
            aRect := DrawFrameEx(FHandle, aRect, FOuterStyle,Light, Shadow,
                        FFrameWidth.Outer);

        { Draw Outer Border }
        if not (ebmTransparent in FMode) then
            aRect := DrawBorder(FHandle, aRect,Border, FFrameWidth.BorderOuter)
        else
            InflateRect(aRect,-FFrameWidth.BorderOuter,-FFrameWidth.BorderOuter);

        { Draw Inner Bevel }
        if (FInnerStyle <> efsNone) then
            aRect := DrawFrameEx(FHandle, aRect, FInnerStyle, Light, Shadow,
                FFrameWidth.Inner);

        { Draw Inner Border }
        if not (ebmTransparent in FMode) then
            aRect := DrawBorder(FHandle, aRect, Border, FFrameWidth.BorderInner)
        else
            InflateRect(aRect,-FFrameWidth.BorderInner,-FFrameWidth.BorderInner);
    end
    else
    Begin
        if (FOuterStyle <> efsNone) then
            aRect := DrawFrameSides(FHandle, aRect, FOuterSides, Light, Shadow,
                    FFrameWidth.Outer, FOuterStyle);

        { Draw Outer Border }
        if not (ebmTransparent in FMode) then
            aRect := DrawBorderSides(FHandle,aRect,FOuterSides, Border,
                    FFrameWidth.BorderOuter)
        else
            aRect := AdjRectSides(aRect,FOuterSides,FFrameWidth.BorderOuter);

        { Draw Inner Bevel }
        if (FInnerStyle <> efsNone) then
            aRect := DrawFrameSides(FHandle, aRect, FInnerSides, Light, Shadow,
                    FFrameWidth.Inner, FInnerStyle);

        { Draw Inner Border }
        if not (ebmTransparent in FMode) then
            aRect := DrawBorderSides(FHandle, aRect, FInnerSides, Border,
                    FFrameWidth.BorderInner)
        else
            aRect := AdjRectSides(aRect,FInnerSides,FFrameWidth.BorderInner);

    end;

    Result := aRect;

End;

{
// --------------------------------------------------------
//  Return if is Empty
// --------------------------------------------------------
}
function TObjBevel.IsEmpty: Boolean;
var
    WInner,
    WOuter : Integer;

    I: Word;

  procedure IncSize(Count: Integer;FS : TEnhSides);
  begin
    if (esdLeft in FS) then
        Inc(I,Count);
    if (esdRight in FS) then
        Inc(I,Count);
    if (esdTop in FS) then
        Inc(I,Count);
    if (esdBottom in FS) then
        Inc(I,Count);
  end;

begin

    I := 0;

    if (ebmCustom in FMode) then
    begin

        WInner := FFrameWidth.BorderInner;
        if (FInnerStyle <> efsNone) then
            Inc(WInner,FFrameWidth.Inner);

        WOuter := FFrameWidth.BorderOuter;
        if (FOuterStyle <> efsNone) then
            Inc(WOuter,FFrameWidth.Outer);

        IncSize(WInner,FInnerSides);
        IncSize(WOuter,FOuterSides);

    end
    else
    begin
        if (FInnerStyle <> efsNone) then
            Inc(I,FFrameWidth.Inner);

        if (FOuterStyle <> efsNone) then
            Inc(I,FFrameWidth.Outer);

        Inc(I,FFrameWidth.BorderOuter);
        Inc(I,FFrameWidth.BorderInner);
    end;

    Result := (I = 0);

end;


{
// --------------------------------------------------------
//  Ajust Rect to Real size (Left, Top, Right, Bottom)
// --------------------------------------------------------
}
function  TObjBevel.AdjustRect(aRect: TRect): TRect;
Var
    WInner,
    WOuter : Integer;
    NotTrans  : Boolean;

Begin

    NotTrans := not (ebmTransparent in Mode);

    WOuter := 0;
    WInner := 0;

    if (FInnerStyle <> efsNone) then
        Inc(WInner,FFrameWidth.Inner);

    if (FOuterStyle <> efsNone) then
        Inc(WOuter,FFrameWidth.Outer);

    if NotTrans then
    Begin
        Inc(WOuter,FFrameWidth.BorderOuter);
        Inc(WInner,FFrameWidth.BorderInner);
    end
    else if (WOuter = 0) then
        WOuter := WInner;


    Result := aRect;

    if (ebmCustom in FMode) then
    begin
        Result := AdjRectSides(Result,FOuterSides,WOuter);

        if NotTrans then
            Result := AdjRectSides(Result,FInnerSides,WInner);
    end
    else { Standar Mode }
    begin
        With Result do
        begin

            if NotTrans then
                Inc(WOuter,WInner);

            Inc(Left,WOuter);
            Inc(Top,WOuter);
            Dec(Right,WOuter);
            Dec(Bottom,WOuter);
        end;
    end;
End;

{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
